<?php

/* Оплата через RBK Money */
class system_of_pay_handler
{
	/* Идентификатор сайта в системе RBK Money, например 12345 */
	var $rbkmoney_id = '12345';

	/* Идентификатор валюты, в которой будет производиться платеж.
	 Сумма к оплате будет пересчитана из валюты магазина в указанную валюту */
	var $rbkmoney_currency_id = 1;

	/* Секретные ключи для кошельков, должны совпадать с настройками сайта на www.rbkmoney.ru */
	var $rbkmoney_secret_key = 'hostmake';

	/* Определяем коэффициент перерасчета цены */
	var $coefficient = 1;
	
	/**
	 * Обработка статуса оплаты
	 *
	 */
	function ProcessResult()
	{
		/* Проверяем сооответствие ID магазина */
		if (!isset($_POST['eshopId']) || $_POST['eshopId'] != $this->rbkmoney_id)
		{
			return false;
		}

		/* Информация о заказе */
		$order_id = to_int($_POST['orderId']);

		if (!$order_id)
		{
			return false;
		}

		$shop = & singleton('shop');

		$order_row = $shop->GetOrder($order_id);

		if (!$order_row)
		{
			return false;
		}

		$shop_row = $shop->GetShop($order_row['shop_shops_id']);

		/* paymentStatus может быть 3 и 5
		 3 - Платеж принят на обработку (нас не интересует)
		 5 - Платеж зачислен
		 */
		if (to_str($_POST['paymentStatus']) == 5)
		{
			// Индикатор запроса
			$eshopId = to_str($_POST["eshopId"]);

			// Внутренний номер покупки продавца
			$orderId = to_str($_POST["orderId"]);

			// Описание покупки
			$serviceName = to_str($_POST["serviceName"]);

			// Номер счета в системе RBKMoney
			$eshopAccount = to_str($_POST["eshopAccount"]);

			// Сумма платежа
			$recipientAmount = to_str($_POST["recipientAmount"]);

			// Валюта платежа
			$recipientCurrency = to_str($_POST["recipientCurrency"]);

			// Статус платежа
			// 3 - Платеж принят на обработку
			// 5 - Платеж зачислен
			$paymentStatus = to_str($_POST["paymentStatus"]);

			// Имя покупателя
			$userName = to_str($_POST["userName"]);

			// Email покупателя
			$userEmail = to_str($_POST["userEmail"]);

			// Дата и время выполнения платежа
			$paymentData = to_str($_POST["paymentData"]);

			/* Проверяем целостность данных */
			$str = $eshopId.'::'.
			$orderId.'::'.
			$serviceName.'::'.
			$eshopAccount.'::'.
			$recipientAmount.'::'.
			$recipientCurrency.'::'.
			$paymentStatus.'::'.
			$userName.'::'.
			$userEmail.'::'.
			$paymentData.'::'.
			$this->rbkmoney_secret_key;

			$str_md5 = md5($str);

			/* Устанавливаем параметры */
			$param = array();
			$param['id'] = $order_row['shop_order_id'];
			$param['shop_shops_id'] = $order_row['shop_shops_id'];

			/* Сравниваем хэши */
			if ($str_md5 == to_str($_POST['hash']))
			{
				// Определим текстовое название статуса
				switch ($paymentStatus)
				{
					case 3:
						$rbkmoney_status_txt = '3 - Платеж принят на обработку';
						break;
					case 5:
						$rbkmoney_status_txt = '5 - Платеж зачислен';
						break;

					default:
						$rbkmoney_status_txt = 'Не определен';
						break;
				}

				/* Проверка прошла успешно!
				 * Добавляем комментарий */
				$param['system_information'] = "Товар оплачен через RBK Money.\n".
				"Атрибуты:\n".
				"Номер сайта продавца: {$eshopId}\n".
				"Внутренний номер покупки продавца: {$orderId}\n".
				"Сумма платежа: {$recipientAmount}\n".
				"Валюта платежа: {$recipientCurrency}\n".
				"Номер счета в системе RBK Mone: {$eshopAccount}\n".
				"Дата и время выполнения платежа: {$paymentData}\n".
				"Статус платежа: {$rbkmoney_status_txt}";

				// Статус оплаты обновляем только если платеж удачно завершен
				if ($paymentStatus == 5)
				{
					/* Устанавливаем признак оплаты */
					//$param['date_of_pay'] = date("Y-m-d H:i:s");
					//$param['status_of_pay'] = true ;

					// Вставка до SetOrderPaymentStatus, иначе флаг оплаты заменится
					$shop->InsertOrder($param);
					
					if ($order_row['shop_order_status_of_pay'] == 0)
					{
						// Изменяем статус оплаты, генерируем ссылки для эл.товаров, списываем товары
						$shop->SetOrderPaymentStatus($order_id);
					}
					
					// Проводки по партнерской программе
					$affiliate = & singleton('affiliate');
					$affiliate->AcceptAffiliatePlanForSiteUsers($order_row['site_users_id'], $order_id);
				}
			}
			else
			{
				$param['system_information'] = 'Хэш не совпал!';
				$shop->InsertOrder($param);
			}

			$order_row = $shop->GetOrder($order_id);
			
			// Отправляем письмо администратору о подтверждении платежа
			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			if (trim(to_str($order_row['shop_order_account_number'])) != '')
			{
				$shop_order_account_number = trim(to_str($order_row['shop_order_account_number']));
			}
			else
			{
				$shop_order_account_number = $order_id;
			}
			
			// Отправляем письмо администратору о подтверждении платежа
			$shop->SendMailAboutOrder($order_row['shop_shops_id'], $order_id, $order_row['site_users_id'],
			to_str($LA['xsl_letter_to_admin']),
			to_str($LA['xsl_letter_to_user']),
			$order_row['shop_order_users_email'],
			array(
			'admin-content-type' => 'html',
			'user-content-type' => 'html',
			'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_admin_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $order_row['shop_order_date_of_pay']),
			'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_user_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $order_row['shop_order_date_of_pay']),
			'email_from_admin' => $order_row['shop_order_users_email']));
		}

		return true;
	}

	/**
	 * Отображает стартовую страницу для оплаты через rbkmoney.
	 *
	 */
	function ShowPurseRequest()
	{
		$shop = & singleton('shop');
		
		/* ID платежной системы берем из сессии */
		$system_of_pay_id = to_int($_SESSION['system_of_pay_id']);
		$row_system_of_pay = $shop->GetSystemOfPay($system_of_pay_id);
		
		if ($row_system_of_pay)
		{
			$shop_id = $row_system_of_pay['shop_shops_id'];
		}
		else
		{
			return false;
		}

		/* Получаем id текущего пользователя сайта */
		if (class_exists('SiteUsers'))
		{
			/* Получаем id текущего пользователя сайта */
			$SiteUsers = & singleton('SiteUsers');
			$site_users_id = $SiteUsers->GetCurrentSiteUser();
		}
		else
		{
			$site_users_id = false;
		}

		// статус платежа, по умолчанию 0
		$order_row['status_of_pay'] = 0;

		// дата платежа, по умолчанию пустая строка
		$order_row['date_of_pay'] = '';

		$order_row['description'] = to_str($_SESSION['description']);

		// описание и системная информация, по умолчанию пустая строка
		if (to_str($_SESSION['shop_coupon_text']) != '')
		{
			$order_row['description'] .= "Купон на скидку: ".to_str($_SESSION['shop_coupon_text'])."\n";
		}

		if (!isset($_SESSION['last_order_id']))
		{
			$_SESSION['last_order_id'] = 0;
		}

		// Если заказ еще не был оформлен
		if ($_SESSION['last_order_id'] == 0)
		{
			/* Оформляем заказ */
			$order_id = $shop->ProcessOrder($shop_id, $site_users_id, $system_of_pay_id, $order_row);
		}
		else
		{
			$order_id = $_SESSION['last_order_id'];
		}

		// Оформление заказа произошло успешно
		if ($order_id > 0)
		{
			if (!class_exists('SiteUsers'))
			{
				/* Класс пользователей сайта не существует, дописываем информацию о заказчике
				 в поле shop_order_description из текущей сессии */
				if ($order_row)
				{
					/* Описание заказчика */
					$order_row['description'] .= "Информация о заказчике:\n"
					."Имя: ".to_str($_SESSION['site_users_name'])."\n"
					."Фамилия: ".to_str($_SESSION['site_users_surname'])."\n"
					."Отчество: ".to_str($_SESSION['site_users_patronymic'])."\n"
					."E-Mail: ".to_str($_SESSION['site_users_email'])."\n"
					."Телефон: ".to_str($_SESSION['site_users_phone'])."\n"
					."Факс: ".to_str($_SESSION['site_users_fax'])."\n"
					."Адрес: ".to_str($_SESSION['full_address'])."\n";

					/* Обязательно добавляем идентификатор! */
					$order_row['id'] = $order_id;

					$shop->InsertOrder($order_row);
				}
			}

			$order_row = $shop->GetOrder($order_id);
			
			if ($order_row)
			{
				$this->PrintOrder($order_id);
			}

			$shop_row = $shop->GetShop($shop_id);
			
			if ($_SESSION['last_order_id'] == 0)
			{
				$structure = & singleton('Structure');
				$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

				$lib = new lib();
				$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

				$date_str = date("d.m.Y H:i:s");

				if (trim(to_str($order_row['shop_order_account_number'])) != '')
				{
					$shop_order_account_number = trim(to_str($order_row['shop_order_account_number']));
				}
				else
				{
					$shop_order_account_number = $order_id;
				}

				/* Отправляем письмо заказчику */
				$shop->SendMailAboutOrder($shop_id,
				$order_id,
				$site_users_id,
				to_str($LA['xsl_letter_to_admin']),
				to_str($LA['xsl_letter_to_user']),
				$order_row['shop_order_users_email'],
				array('admin-content-type' => 'html',
				'user-content-type' => 'html',
				'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_admin_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_user_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'email_from_admin' => $order_row['shop_order_users_email']));
			}
				
			// Сохраняем ID последнего оформленного заказа ТОЛЬКО ПОСЛЕ ОТПРАВКИ ПИСЬМА
			$_SESSION['last_order_id'] = $order_id;
		}
		else
		{
			switch ($order_id)
			{
				case -1:
					{
						?><div id="error">Ошибка вставки заказа в базу данных. Обратитесь к администратору.</div><?php
						break;
					}
				case -2:
					{
						?><div id="error">Ошибка - не найден магазин. Обратитесь к администратору.</div><?php
						break;
					}
				case -3:
					{
						?><div id="error">Ошибка - корзина пуста. Добавьте товар в корзину и оформите заказ.</div><?php
						break;
					}
			}
		}

		return true;
	}

	/**
	 * Метод, запускающий выполнение обработчика
	 *
	 */
	function Execute()
	{
		/* Обработка статуса оплаты */
		if (isset($_POST['eshopId'])
		&& isset($_POST['paymentId'])
		&& isset($_POST['paymentStatus']))
		{
			$this->ProcessResult();
			return true;
		}

		/* Иначе оформляем заказ и отображаем стартовую страницу для оплаты */
		$this->ShowPurseRequest();

		return true;
	}

	/**
	 * Метод для отображения формы заказа для печати.
	 *
	 * @param int $order_id идентификатор заказа
	 */
	function PrintOrder($order_id)
	{
		$shop = & singleton('shop');
		$order_row = $shop->GetOrder($order_id);
		if (!$order_row)
		{
			return false;
		}
				
		if ($order_row)
		{
			$shop_row = $shop->GetShop($order_row['shop_shops_id']);

			/* Делаем перерасчет суммы в валюту */
			$shop_currency_id = $shop_row['shop_currency_id'];

			$order_sum = $shop->GetOrderSum($order_id) * $this->coefficient;
			
			/* Определяем коэффициент пересчета */
			$currency_coefficient = $shop->GetCurrencyCoefficientToShopCurrency($shop_currency_id, $this->rbkmoney_currency_id);
			$sum = round($order_sum * $currency_coefficient, 2);

			// округляем до десятых после запятой
			$sum = round($sum, 2);

			/* Информация об алиасе сайта */
			$site = & singleton ('site');
			$site_alias = $site->GetCurrentAlias($shop_row['site_id']);

			/* Получаем путь к магазину */
			$Structure = & singleton('Structure');
			$shop_path = '/' . $Structure->GetStructurePath($shop_row['structure_id'], 0);

			$handler_url = 'http://'.$site_alias.$shop_path."cart/?order_id={$order_id}";

			$successUrl = $handler_url . "&payment=success";
			$failUrl = $handler_url . "&payment=fail";
			
			// Поулчаем название валюты, чтобы указать пользователю и передать в магазин
			$currency_row = $shop->GetCurrency($this->rbkmoney_currency_id);
			
			if ($currency_row)
			{
				?>
				<h1>Оплата через систему RBK Money</h1>
				<p>Сумма к оплате составляет <strong><?php echo $sum?> <?php echo $currency_row['shop_currency_name']?></strong></p>
				
				<p>Для оплаты нажмите кнопку "Оплатить".</p>
				
				<form action="https://rbkmoney.ru/acceptpurchase.aspx" name="pay"
					method="post"><input type="hidden" name="eshopId"
					value="<?php echo $this->rbkmoney_id?>"> <input type="hidden"
					name="orderId" value="<?php echo $order_id?>"> <input type="hidden"
					name="serviceName" value="Оплата счета N <?php echo $order_id?>"> <input
					type="hidden" name="recipientAmount" value="<?php echo $sum?>">
					<input type="hidden" name="recipientCurrency" value="<?php echo $currency_row['shop_currency_international_name']?>">
					<input type="hidden" name="successUrl" value="<?php echo $successUrl?>">
					<input type="hidden" name="failUrl" value="<?php echo $failUrl?>">
					<input type="submit" name="button" value="Оплатить">
				</form>

				<h1>Оплатить Visa &amp; MasterCard через систему RBK Money</h1>

				<p>Сумма к оплате составляет <strong><?php echo $sum?> <?php echo $currency_row['shop_currency_name']?></strong></p>
				
				<p>Для оплаты нажмите кнопку "Оплатить".</p>

				<form action="https://rbkmoney.ru/acceptpurchase.aspx" method="POST">
					<input type="hidden" name="eshopId" value="<?php echo $this->rbkmoney_id?>">
					<input type="hidden" name="recipientAmount" value="<?php echo $sum?>">
					<input type="hidden" name="recipientCurrency" value="<?php echo $currency_row['shop_currency_international_name']?>">
					<input type="hidden" name="orderId" value="<?php echo $order_id?>">
					<input type="hidden" name="user_email" value="<?php echo $order_row['shop_order_users_email']?>">
					<input type="hidden" name="serviceName" value="Оплата счета N <?php echo $order_id?>">
					<input type="hidden" name="preference" value="bankCard">
					<input type="hidden" name="successUrl" value="<?php echo $successUrl?>">
					<input type="hidden" name="failUrl" value="<?php echo $failUrl?>">
					<input type="submit" name="button" value="Оплатить">
				</form>
				
				<?php
			}
			else
			{
				?>
				<h1>Не найдена валюта с идентификатором <?php $this->rbkmoney_currency_id?>!</h1>
				<?php
			}
		}

	}

	/**
	 * Изменение статуса заказа. Позволяет пользователю внедрять собственные
	 * обработчики при изменении статуса.
	 *
	 * @param array $param массив атрибутов
	 * - $param['shop_order_id'] идентификатор заказа
	 * - $param['prev_order_row'] информация о предыдущем состоянии заказа (доступно не всегда)
	 * - $param['action'] выполняемое действие над заказом, может принимать значения:
	 * edit (редактирование заказа), cancel (отмена заказа),
	 * status (изменение статуса заказа), delete (удаление заказа),
	 * edit_item (редактирование товара в заказе), delete_item (удаление товара в заказе)
	 */
	function ChangeStatus($param = array())
	{
		// Если произошло изменение статуса или
		if (isset($param['action']) && in_array($param['action'], array('status', 'edit')))
		{
			$shop_order_id = to_int($param['shop_order_id']);

			$shop = & singleton('shop');

			$order_row = $shop->GetOrder($shop_order_id);

			// Получаем информацию о магазине
			$shop_id = to_int($order_row['shop_shops_id']);

			$shop_row = $shop->GetShop($shop_id);

			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			if ($order_row)
			{
				$DateClass = new DateClass();
				$date_str = $DateClass->datetime_format($order_row['shop_order_date_time']);
			}
			else
			{
				$date_str = '';
			}

			// Если предыдущий статус заказа был 1, то меняем тему на подтверждение
			if (to_int($order_row['shop_order_status_of_pay']) == 1)
			{
				$admin_subject = $GLOBALS['MSG_shops']['shop_order_confirm_admin_subject'];
				$user_subject = $GLOBALS['MSG_shops']['shop_order_confirm_user_subject'];
			}
			else
			{
				$admin_subject = $GLOBALS['MSG_shops']['shop_order_admin_subject'];
				$user_subject = $GLOBALS['MSG_shops']['shop_order_user_subject'];
			}

			$not_paid = isset($param['prev_order_row']) && $param['prev_order_row']['shop_order_status_of_pay'] == 0;
			
			// Письмо отправляем только при установке статуса активности для заказа
			if (to_int($order_row['shop_order_status_of_pay']) == 1 && $not_paid)
			{
				if (trim(to_str($order_row['shop_order_account_number'])) != '')
				{
					$shop_order_account_number = trim(to_str($order_row['shop_order_account_number']));
				}
				else
				{
					$shop_order_account_number = $shop_order_id;
				}

				/* Отправляем письмо заказчику */
				$shop->SendMailAboutOrder($shop_id,
				$shop_order_id,
				$order_row['site_users_id'],
				to_str($LA['xsl_letter_to_admin']),
				to_str($LA['xsl_letter_to_user']),
				$order_row['shop_order_users_email'],
				array('admin-content-type' => 'html',
				'user-content-type' => 'html',
				'admin-subject' => sprintf($admin_subject, $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'user-subject' => sprintf($user_subject, $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'email_from_admin' => $order_row['shop_order_users_email']));
			}
		}
	}
}
?>